import java.applet.*;
import java.awt.*;
import java.util.*;
import java.text.*;
import java.io.*;

import netscape.javascript.*;


public class FooApplet extends Applet
{
	long baseTime = System.currentTimeMillis();
	boolean trace = true;
	String currFunc = null;

// ========================= Applet Entry Points =============================

	public void init()
	{
		if (trace)
			println("FooApplet.init()");
		setBackground(Color.RED);
		if (trace)
			println("FooApplet.init() complete");
	}

	public void start() 
	{
		if (trace) 
			println("FooApplet.start()");
		doValidate();
		winCall("foo_start", 
			new Object[] {new Boolean(false)} );
		setBackground(Color.BLUE);
		if (trace) 
			println("FooApplet.start() complete");
	}

	public String validateFromJS()
	{
		return("I'M HERE");
	}

	public void doValidate()
	{
		try {
			println("doValidate calling js foo_validateFromJava()");
			Object result = winCall("foo_validateFromJava", new Object[] { });
			println("foo_validateFromJava() returns " + result);
			if (result == null || !result.equals("WORKING")) {
				setBackground(Color.BLACK);
				throw (new Error("validation failure between js and java"));
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void stop()
	{
		if (trace)
			println("FooApplet.stop()");
		setBackground(Color.RED);
	}


// ============================= Maintenance ===============================

	/* JS CALLED */
	public void println(Object obj)
	{
		System.out.println(milliTime() + " " + obj.toString());
	}

	public long milliTime()
	{
		return(System.currentTimeMillis() - baseTime);
	}

	/* synchronized*/  Object winCall(String name, Object[] args)
	{
		Object result = null;

		/*
		System.out.print("winCall: " + name + "(");
		for (int i=0; i<args.length; i++)
			System.out.print(args[i] + " ");
		println(")");
		*/
		
		
		/*
		if (currFunc != null) {
			println("winCall over-and-back: " + currFunc
				+ " then " + name);
		}
		*/
		currFunc = name;

		try {
			// commentary found in developer forum suggested that the window
			// handle sometimes goes stale, hence, we are not caching it. This
			// means there is no instance of JSObject in javaland for more
			// time than between the next two statements.

			// unfortunately, there's also a bug in Mozilla-bugzilla (165176)
			// that claims repeated calls to getWindow() also cause a hang.

			JSObject win = JSObject.getWindow(this);
			result = win.call(name, args);
		} catch (JSException jse) {
			currFunc = null;

			System.out.print("winCall: " + name + "(");
			for (int i=0; i<args.length; i++)
				System.out.print(args[i] + " ");
			println(")");

			jse.printStackTrace();
			// throw (new Error("JSException on window call"));
		}

		// println("winCall: " + currFunc + " returns " + result);

		currFunc = null;

		return(result);
	}
}
